(*
   module Primitives
   Primitive functions and constructors and.
*)

open Types

(* Numbers using these constructors are parsed from/printed as
   "0.", "1.", ...
   Bare numbers are instead parsed as TermLiteral(Num _) *)
val _Zero :   constructor (* adicity 0 *)
val _Succ :   constructor (* adicity 1 *)
(** FIXME use destructor instead?
val _Pred :   primfun (* adicity 1 *)
**)

(* The following (infix) operators can only be used on
   bare numbers, not 0., 1., and so on *)
val _Leq :    primfun (* adicity 2 *)
val _Lt :     primfun (* adicity 2 *)
val _Eq :     primfun (* adicity 2 *)
val _Plus :   primfun (* adicity 2 *)
val _Minus :  primfun (* adicity 2 *)
val _Times :  primfun (* adicity 2 *)

val _Not :    primfun (* adicity 1 *)

(* Parsed from/printed as (), (,) and (,,) *)
val _Unit :   constructor (* adicity 0 *)
val _Pair :   constructor (* adicity 2 *)
val _Triple : constructor (* adicity 3 *)

(* This is a 1-tuple, parsed from/printed as (box _).
   We will build on this in later weeks. *)
val _Box :    constructor (* adicity 1 *)
